题目:

已知一个长度为 n 的数组,预先按照升序排列,经由 1 到 n 次 旋转 后,得到输入数组。例如,原数组 nums = [0,1,2,4,5,6,7] 在变化后可能得到:
若旋转 4 次,则可以得到 [4,5,6,7,0,1,2]
若旋转 7 次,则可以得到 [0,1,2,4,5,6,7]
注意,数组 [a[0], a[1], a[2], ..., a[n-1]] 旋转一次 的结果为数组 [a[n-1], a[0], a[1], a[2], ..., a[n-2]] 。

给你一个元素值互不相同 的数组 nums ,它原来是一个升序排列的数组,并按上述情形进行了多次旋转。请你找出并返回数组中的最小元素 。

你必须设计一个时间复杂度为 O(log n) 的算法解决此问题。

示例 1:

输入:nums = [3,4,5,1,2]
输出:1
解释:原数组为 [1,2,3,4,5] ,旋转 3 次得到输入数组。
示例 2:

输入:nums = [4,5,6,7,0,1,2]
输出:0
解释:原数组为 [0,1,2,4,5,6,7] ,旋转 4 次得到输入数组。
示例 3:

输入:nums = [11,13,15,17]
输出:11
解释:原数组为 [11,13,15,17] ,旋转 4 次得到输入数组。

提示:

  • n == nums.length
  • 1 <= n <= 5000
  • -5000 <= nums[i] <= 5000
  • nums 中的所有整数 互不相同
  • nums 原来是一个升序排序的数组,并进行了 1 至 n 次旋转

来源:力扣(LeetCode)
链接:https://leetcode.cn/problems/find-minimum-in-rotated-sorted-array
著作权归领扣网络所有。商业转载请联系官方授权,非商业转载请注明出处。

解题思路:

【暴力解法】

直接遍历数组的每个数,然后更新最小值,遍历完后最小值也就得到了。

1 class Solution {
2 public int findMin(int[] nums) {
3 int MinNum = nums[0], n = nums.length;
4 for (int i = 0; i < n; i++){
5 MinNum = Math.min(MinNum, nums[i]);
6 }
7 return MinNum;
8 }
9 }

 【二分查找】

题解参考@【liweiwei1419】:https://leetcode.cn/problems/find-minimum-in-rotated-sorted-array/solution/er-fen-fa-fen-zhi-fa-python-dai-ma-java-dai-ma-by-/(疯狂安利这位老师,他的二分查找讲的很细致)

旋转数组的特点:

1.多次旋转等价于一次旋转:因为除了旋转n次得到的是原数组以外,其他都将原数组分为了两个升序区间;

2.旋转后的数组中最大值和最小值相邻:如果最大值的右边存在的话,那么最大值右边的数一定是最小值;

3.如果两点是上升的,那么两点之前意思一定是上升的。也就是如果左边 < 中间,则从左边到中间就一定是上升的。看图理解:

如果是图片这样,那么原数组就一定不是升序的,所以旋转以后才是这样。

这样的话,和之间不包含重复元素的旋转数组寻找目标值的写法差不多,区别在于一个是找目标值一个是找最小值。这个最小值的查找就需要中间值与左右两端值的比较,来缩小查找区间,从而想到用二分查找,但是中间值和左端值比较,还是右端值比较呢?下面分别列举出左右两端的比较情况再做决定!

1.比较 左边 和 中间:

上图两种情况,左边 都小于 中间,但是最小值一个中间值的后面,一个在中间值的前面。特例就是,最小值在第一个位置上。

实例:

eg1:[1,2,3,4,5]  中间数3

eg2:[3,4,5,1,2]  中间数5

两个例子的中间数都大于左边,但是最小值一个在中位数的左边,一个在中位数的右边。

2.比较 右边 和 中间:

上图两种情况,右边 都大于 中间,最小值都在中间值的前面。

最极端的情况就是,最小值就在中间。

实例:

eg1:[7,8,9,10,1,2,3]  中间数10,比右边界3大,因此中间数左边的数以及中间数都不是最小值,这时需要缩小搜索区间,往右走,左边界设置为left = mid + 1;

eg2:[6,7,1,2,3]  中间数1,比3小,说明1-3这个区间是升序的,那么中间数右边的数一定不是最小数(但是中间数就可能是最小数),故缩小搜索区间,设置有右边界为right = mid;

注意:这里的搜索区间变换,left != mid,即没有在[mid, right]之间哦,所以mid就向下取整就可以!!!

所以,为了操作方便,直接比较中间值和右边。

  • while (left < right)
  • nums[mid] < nums[right]:有可能mid就是最小值,故搜索区间为[left, mid] 即right = mid;
  • nums[mid] > nums[right]:最小值一定在mid的右边,故搜索区间为[mid+ 1, right] 即left = mid +1;
  • 循环结束是left == mid,且一定存在最小元素,直接返回nums[left]即可。

java代码(left < right):

 1 class Solution {
2 public int findMin(int[] nums) {
3 int left = 0, right = nums.length - 1;
4 while (left < right){
5 int mid = left + (right - left) / 2;
6 if (nums[mid] < nums[right]){
7 //nums[mid]有可能就是最小值
8 //搜索区间为[left, mid]
9 right = mid;
10 }else {
11 //nums[mid] > nums[right],mid一定不是最小值
12 //搜索区间为[mid + 1, right]
13 left = mid + 1;
14 }
15 }
16 //一定有最小值,不用继续判断
17 return nums[left];
18 }
19 }

 python3代码(left <= right):

 1 class Solution:
2 def findMin(self, nums: List[int]) -> int:
3 left, right = 0, len(nums) - 1
4 while left <= right:
5 mid = left + (right - left) // 2
6 if nums[mid] < nums[right]:
7 right = mid
8 else:
9 left = mid + 1
10 return nums[right]

力扣153(java&python)-寻找旋转排序数组中的最小值(中等)的更多相关文章

  1. 领扣(LeetCode)寻找旋转排序数组中的最小值 个人题解

    假设按照升序排序的数组在预先未知的某个点上进行了旋转. ( 例如,数组 [0,1,2,4,5,6,7] 可能变为 [4,5,6,7,0,1,2] ). 请找出其中最小的元素. 你可以假设数组中不存在重 ...

  2. Java实现 LeetCode 153 寻找旋转排序数组中的最小值

    153. 寻找旋转排序数组中的最小值 假设按照升序排序的数组在预先未知的某个点上进行了旋转. ( 例如,数组 [0,1,2,4,5,6,7] 可能变为 [4,5,6,7,0,1,2] ). 请找出其中 ...

  3. LeetCode:寻找旋转排序数组中的最小值【153】

    LeetCode:寻找旋转排序数组中的最小值[153] 题目描述 假设按照升序排序的数组在预先未知的某个点上进行了旋转. ( 例如,数组 [0,1,2,4,5,6,7] 可能变为 [4,5,6,7,0 ...

  4. Leetcode之二分法专题-153. 寻找旋转排序数组中的最小值(Find Minimum in Rotated Sorted Array)

    Leetcode之二分法专题-153. 寻找旋转排序数组中的最小值(Find Minimum in Rotated Sorted Array) 假设按照升序排序的数组在预先未知的某个点上进行了旋转. ...

  5. [LeetCode每日一题]153.寻找旋转排序数组中的最小值

    [LeetCode每日一题]153.寻找旋转排序数组中的最小值 问题 已知一个长度为 n 的数组,预先按照升序排列,经由 1 到 n 次 旋转 后,得到输入数组.例如,原数组 nums = [0,1, ...

  6. 【leetcode】153. 寻找旋转排序数组中的最小值

    题目链接:传送门 题目描述 现有一个有序数组,假设从某个数开始将它后面的数按顺序放到了数组前面.(即 [0,1,2,4,5,6,7] 可能变成 [4,5,6,7,0,1,2]). 请找出数组中的最小元 ...

  7. Java实现 LeetCode 154 寻找旋转排序数组中的最小值 II(二)

    154. 寻找旋转排序数组中的最小值 II 假设按照升序排序的数组在预先未知的某个点上进行了旋转. ( 例如,数组 [0,1,2,4,5,6,7] 可能变为 [4,5,6,7,0,1,2] ). 请找 ...

  8. [LeetCode] 154. 寻找旋转排序数组中的最小值 II

    题目链接 : https://leetcode-cn.com/problems/find-minimum-in-rotated-sorted-array-ii/ 题目描述: 假设按照升序排序的数组在预 ...

  9. lintcode:寻找旋转排序数组中的最小值 II

    寻找旋转排序数组中的最小值 II 假设一个旋转排序的数组其起始位置是未知的(比如0 1 2 4 5 6 7 可能变成是4 5 6 7 0 1 2). 你需要找到其中最小的元素. 数组中可能存在重复的元 ...

  10. LeetCode153.寻找旋转排序数组中的最小值

    153.寻找旋转排序数组中的最小值 描述 假设按照升序排序的数组在预先未知的某个点上进行了旋转. ( 例如,数组 [0,1,2,4,5,6,7] 可能变为 [4,5,6,7,0,1,2] ). 请找出 ...

随机推荐

  1. C#项目管理引用的dll文件

    这篇文章主要简单记录一下C#项目的dll文件管理方法,以便后期使用. 设置dll路径 参考C#开发奇技淫巧三:把dll放在不同的目录让你的程序更整洁中间的 方法一:配置App.config文件的pri ...

  2. Navicat 15下载教程

    Navicat 15下载_永久激活注册码(附图文安装教程) 欢迎关注博主公众号「java大师」, 专注于分享Java领域干货文章, 关注回复「资源」, 免费领取全网最热的Java架构师学习PDF, 转 ...

  3. Kettle实战视频教程

    kettle实战视频教程 欢迎关注笔者的公众号: java大师, 每日推送java.kettle运维等领域干货文章,关注即免费无套路附送 100G 海量学习.面试资源哟!!个人网站: http://w ...

  4. 2024-03-16:用go语言,给你一个正整数数组 nums, 每一次操作中,你可以从 nums 中选择 任意 一个数并将它减小到 恰好 一半。 (注意,在后续操作中你可以对减半过的数继续执行操作)

    2024-03-16:用go语言,给你一个正整数数组 nums, 每一次操作中,你可以从 nums 中选择 任意 一个数并将它减小到 恰好 一半. (注意,在后续操作中你可以对减半过的数继续执行操作) ...

  5. 低代码平台前端的设计与实现(二)构建引擎BuildEngine切面处理设计

    上一篇文章,我们介绍了如何设计并实现一个轻量级的根据JSON的渲染引擎,通过快速配置一份规范的JSON文本内容,就可以利用该JSON生成一个基础的UI界面.本文我们将回到低开的核心-页面拖拉拽,探讨关 ...

  6. 3D渲染速度慢,花重金买显卡还是用云渲染更划算

    3D渲染对建筑师和设计师来说并不陌生,3D渲染的过程中出现渲染卡顿.特殊材质难以渲染,或者本地配置不足.本地渲染资源不够时,常常会影响工作效率.本文比较了3D渲染时,为提高工作效率,买显卡还是用云渲染 ...

  7. python基础九(模块和包)

    一 模块介绍 1.什么是模块? 模块就是一系列功能的集合体,分为三大类 I:内置的模块(python解释器内置) II:第三方的模块 III:自定义的模块 一个python文件本身就是一个模块,文件名 ...

  8. 前端ajax调用后端下载Excel模板流,解决输出乱码等问题

    JavaScript方法function importTemplate() { $.ajax({ url: "/importTemplate", type: "get&q ...

  9. Zotero 插件:DOI Manager 使用

    一.项目信息与下载安装 https://github.com/bwiernik/zotero-shortdoi 根据readme,下载并安装即可.可能访问会失败,多试几次,总是能够成功的. 本博客编写 ...

  10. 访问数据库 与 Java框架各层级

    目录 访问数据库流程 Java框架各层级 4 层 对象的调用流程 耦合性与分层 项目地址:https://github.com/aijisjtu/Bot-Battle 访问数据库流程 flowchar ...